// DIB_DECALCONTROL.JS
//
// Author:	Maud-Dib
// Version:	2.06
//
// Modification History
//
// Who	  Date	    Version	Description
//
// MD	  06/23/02  1.01	Initial version
//
//
// Description:
//
//	This module contains all the routines related to decal controls
//

// Define decal-like interface
function DefineSchemas() {

    // Miscellaneous schemas, used in multiple places below.
    szSchemaSpellLevels = "";
    for (var x=7; x>0; x--) szSchemaSpellLevels = szSchemaSpellLevels + " <option text='" + x + "'/>\n";

    szSchemaSpellLevel2 = "";
    for (var x=6; x>0; x--) szSchemaSpellLevel2 = szSchemaSpellLevel2 + " <option text='" + x + "'/>\n";

    szSchemaSpellLevel3 = "";
    for (var x=6; x>=0; x--) szSchemaSpellLevel3 = szSchemaSpellLevel3 + " <option text='" + x + "'/>\n";

    szSchemaSpellCnt = "";
    for (var x=0; x<6; x++) szSchemaSpellCnt +=  " <option text='" + x + "'/>\n";
    
    szSchemaHealLvl = "";
    for (var x=0; x<251; x+=10) szSchemaHealLvl +=  " <option text='" + x + "'/>\n";

    // Define control panel schema
    szSchemaControlBegin =
	"<view title='" + szPanelControl + "' iconlibrary='Inject.dll' icon='128' \n" +
	"  width='120' height='345'>\n" +
	"  <control progid='DecalControls.FixedLayout'>\n" +
	"    <control name='controlTab' progid='DecalControls.Notebook' " +
	"     left='0' top='0' width='120' height='345'>\n";
	
    szSchemaControl_C1 =
	"	<page label='C1'>\n" +
	"       <control progid='DecalControls.FixedLayout'>\n" +
	"         <control name='btnPause'          progid='DecalControls.PushButton'  text='Pause' \n" +
	"	   left='10'  top='10'  width='100' height='18' />\n" +
	"         <control name='btnSummonMode'     progid='DecalControls.PushButton'  text='Enable Summoning' \n" +
	"	   left='10'  top='30'  width='100' height='18' />\n" +
	"         <control name='btnBuffMode'       progid='DecalControls.PushButton'  text='Enable Buffing' \n" +
	"	   left='10'  top='50'  width='100' height='18' />\n" +
	"         <control name='btnPlayers'        progid='DecalControls.PushButton'  text='Show Players' \n" +
	"          left='10'  top='110' width='100' height='18' />\n" +
	"         <control name='btnStats'          progid='DecalControls.PushButton'  text='Show Stats' \n" +
	"          left='10'  top='130'  width='100' height='18' />\n" +
	"         <control name='btnShowComps'      progid='DecalControls.PushButton'  text='Show Comps' \n" +
	"          left='10'  top='150' width='100' height='18' />\n" +
	"         <control name='btnVersion'        progid='DecalControls.PushButton'  text='Show Version' \n" +
	"          left='10'  top='170' width='100' height='18' />\n" +
	"         <control name='btnResetStats'     progid='DecalControls.PushButton'  text='Clear Stats' \n" +
	"          left='10'  top='190' width='100' height='18' />\n" +
	"         <control name='btnForceAll'       progid='DecalControls.PushButton'  text='Force All Buffs' \n" +
	"	   left='10'  top='210' width='100' height='18' />\n" +
	"	</control>\n" +
	"       </page>\n";

    var Offset = 30;
    szSchemaControl_C2a = "";
    for (var x=0; x<skapi.cchar; x++) {
   	var TruncCharName = Util.Trim(skapi.rgszChar(x));
	szSchemaControl_C2a = szSchemaControl_C2a +
	"     <control name='btnChar" + x + "'  progid='DecalControls.PushButton'  text=\"" + TruncCharName + "\" \n" +
	"      left='10'  top='" + Offset + "'  width='100' height='18' />\n";
	Offset += 20;
    } // end for

    szSchemaControl_C2 =
	"	<page label='C2'>\n" +
	"       <control progid='DecalControls.FixedLayout'>\n" +
	"         <control name='textC2' progid='DecalControls.StaticText'  text='Switch to...' \n" +
	"	   left='10'  top='10'  width='100' height='18' />\n" +
	          szSchemaControl_C2a +
	"	</control>\n" +
	"       </page>\n";

    szSchemaControl_S =
	"	<page label='S'>\n" +
	"       <control progid='DecalControls.FixedLayout'>\n" +
	"         <control name='btnFillComps'     progid='DecalControls.PushButton'  text='Fillcomps' \n" +
	"	   left='10' top='10'  width='100' height='18' />\n" +
	"         <control name='btnLifeStone'     progid='DecalControls.PushButton'  text='Lifestone' \n" +
	"	   left='10' top='30'  width='100' height='18' />\n" +
	"         <control name='btnHouse'         progid='DecalControls.PushButton'  text='House Recall' \n" +
	"	   left='10' top='50'  width='100' height='18' />\n" +
	"         <control name='btnMansion'       progid='DecalControls.PushButton'  text='Mansion Recall' \n" +
	"	   left='10' top='70'  width='100' height='18' />\n" +
	"         <control name='btnMarket'        progid='DecalControls.PushButton'  text='Marketplace' \n" +
	"	   left='10' top='90'  width='100' height='18' />\n" +
	"         <control name='btnStoneRecall'   progid='DecalControls.PushButton'  text='Life Stone Recall' \n" +
	"	   left='10' top='110' width='100' height='18' />\n" +
	"         <control name='btnPortal1Recall' progid='DecalControls.PushButton'  text='Portal 1 Recall' \n" +
	"	   left='10' top='130' width='100' height='18' />\n" +
	"         <control name='btnPortal2Recall' progid='DecalControls.PushButton'  text='Portal 2 Recall' \n" +
	"	   left='10' top='150' width='100' height='18' />\n" +
	"         <control name='btnPortalRecall'  progid='DecalControls.PushButton'  text='Portal Recall' \n" +
	"	   left='10' top='170' width='100' height='18' />\n" +
	"         <control name='btnRecallSanct'   progid='DecalControls.PushButton'  text='Recall Sanctuary' \n" +
	"	   left='10' top='190' width='100' height='18' />\n" +
	"         <control name='btnUlgrimRecall'  progid='DecalControls.PushButton'  text='Ulgrims Recall' \n" +
	"	   left='10' top='210' width='100' height='18' />\n" +
	"         <control name='btnCaulRecall'    progid='DecalControls.PushButton'  text='Caul Recall' \n" +
	"	   left='10' top='230' width='100' height='18' />\n" +
	"         <control name='btnAphusRecall'   progid='DecalControls.PushButton'  text='Recall Aphus Lassel' \n" +
	"	   left='10' top='250' width='100' height='18' />\n" +
	"	</control>\n" +
	"       </page>\n";

    szSchemaControl_D =
	"	<page label='D'>\n" +
	"       <control progid='DecalControls.FixedLayout'>\n" +
	"	   left='10' top='10'  width='100' height='18' />\n" +
	"         <control name='btnShowBuffs'     progid='DecalControls.PushButton'  text='Show Buffs' \n" +
	"	   left='10' top='30'  width='100' height='18' />\n" +
	"         <control name='btnAnalSel'       progid='DecalControls.PushButton'  text='Analyze Selected' \n" +
	"          left='10' top='50'  width='100' height='18' />\n" +
	"         <control name='textCmd'          progid='DecalControls.StaticText'  text='Eval Command' \n" +
	"	   left='20' top='75'  width='100' height='16' />\n" +
	"         <control name='editCmd'          progid='DecalControls.Edit' \n" +
	"	   left='5'  top='92'  width='110' height='18' \n" +
	"	   marginx='12' marginy='2' imageportalsrc='4726' text='' />\n" +
	"	</control>\n" +
	"       </page>\n";

    szSchemaControlEnd =
	"    </control>\n" +
	"  </control>\n" +
	"</view>";

    szSchemaControl = szSchemaControlBegin + szSchemaControl_C1 + szSchemaControl_C2 +
    		      szSchemaControl_S    + szSchemaControl_D  + szSchemaControlEnd

    // Build config schema.  We break it down into several section due to the size of each piece
    szSchemaConfig1 =
	"<view title='" + szPanelConfig + "' iconlibrary='Inject.dll' icon='128' \n" +
	"  width='220' height='355'>\n" +
	"  <control progid='DecalControls.FixedLayout'>\n" +
	"    <control name='spellTab' progid='DecalControls.Notebook' " +
	"     left='0' top='0' width='230' height='355'>\n";

    szSchemaConfig2 =
	"	<page label='G1'>\n" +
	"	<control progid='DecalControls.FixedLayout'>\n" +
	"         <control name='textGen'        progid='DecalControls.StaticText' text='Configuration Management' \n" +
	"	   left='10' top='8' width='140'    height='18' />\n" +

	"         <control name='btnGenLoad'        progid='DecalControls.PushButton' text='Load' \n" +
	"	   left='10'  top='25' width='60'   height='18' />\n" +
	"         <control name='btnGenSave'        progid='DecalControls.PushButton' text='Save' \n" +
	"	   left='10'  top='47' width='60'   height='18' />\n" +
	"         <control name='btnGenReset'       progid='DecalControls.PushButton' text='Reset' \n" +
	"	   left='10'  top='69'  width='60'  height='18' />\n" +

	"         <control name='textMisc'          progid='DecalControls.StaticText' text='General' \n" +
	"	   left='10'  top='97'  width='160' height='16' />\n" +
	
	"         <control name='chkCreatureHide'   progid='DecalControls.CheckBox'  text='Creature detect log' \n" +
	"	   left='10'  top='117' width='150' height='16'  checked='false'/>\n" +
	"         <control name='chkCreatureWarn'   progid='DecalControls.CheckBox'  text='Creature detect warn' \n" +
	"	   left='10'  top='137' width='150' height='16'  checked='false'/>\n" +	
	"         <control name='chkDeathLog'       progid='DecalControls.CheckBox'  text='Log on death' \n" +
	"	   left='10'  top='157' width='150' height='16'  checked='false'/>\n" +
	"         <control name='chkDamageLog'      progid='DecalControls.CheckBox'  text='Log on damage' \n" +
	"	   left='10'  top='177' width='150' height='16'  checked='false'/>\n" +
	"         <control name='chkReduceBurden'   progid='DecalControls.CheckBox'  text='Reduce burden' \n" +
	"          left='10'  top='197' width='150' height='16' checked='false'/>\n" +
	"         <control name='chkAutoResume'     progid='DecalControls.CheckBox'  text='Auto resume' \n" +
	"	   left='10'  top='217' width='150' height='16'  checked='false'/>\n" +
	"         <control name='chkWarAvoid'       progid='DecalControls.CheckBox'  text='Avoid war' \n" +
	"          left='10'  top='237' width='150' height='16' checked='false'/>\n" +
	"         <control name='chkSlideCast'      progid='DecalControls.CheckBox'  text='Slide cast' \n" +
	"          left='10'  top='257' width='150' height='16' checked='false'/>\n" +
	"         <control name='chkRespondWhere'   progid='DecalControls.CheckBox'  text='Respond to !whereto' \n" +
	"          left='10'  top='277' width='150' height='16' checked='false'/>\n" +
	"	</control>\n" +
	"       </page>\n";

   szSchemaConfig3 =
	"	<page label='P1'>\n" +
	"	<control progid='DecalControls.FixedLayout'>\n" +
	"         <control name='textP1'            progid='DecalControls.StaticText' text='Summoning Options' \n" +
	"	   left='10'  top='8'   width='150' height='18' />\n" +

	"         <control name='chkCloseBy'        progid='DecalControls.CheckBox' text='Requestor must be close' \n" +
	"	   left='10'  top='28'  width='170' height='16'  checked='false'/>\n" +
	"         <control name='chkPortalGems'     progid='DecalControls.CheckBox' text='Use portal gems' \n" +
	"	   left='10'  top='48'  width='170' height='16'  checked='false'/>\n" +
	"         <control name='chkAutoRotate'     progid='DecalControls.CheckBox' text='Auto Rotate' \n" +
	"	   left='10'  top='68'  width='170' height='16'  checked='false'/>\n" +
	"         <control name='chkAvoidStorms'    progid='DecalControls.CheckBox' text='Avoid portal storms' \n" +
	"	   left='10'  top='88'  width='170' height='16'  checked='false'/>\n" +
	"         <control name='chkAdvertise'      progid='DecalControls.CheckBox' text='Advertise services' \n" +
	"	   left='10'  top='108' width='170' height='16'  checked='false'/>\n" +
	"         <control name='chkOpenMsg'        progid='DecalControls.CheckBox' text='Open message' \n" +
	"	   left='10'  top='128' width='170' height='16'  checked='false'/>\n" +
	"         <control name='chkAckGifts'       progid='DecalControls.CheckBox' text='Acknowledge gifts' \n" +
	"	   left='10'  top='148' width='170' height='16'  checked='false'/>\n" +
	"         <control name='chkLogGifts'       progid='DecalControls.CheckBox' text='Log gifts' \n" +
	"	   left='10'  top='168' width='170' height='16'  checked='false'/>\n" +
	"         <control name='chkLogStats'       progid='DecalControls.CheckBox' text='Log hourly stats' \n" +
	"	   left='10'  top='188' width='170' height='16'  checked='false'/>\n" +
	"         <control name='chkLogCmds'        progid='DecalControls.CheckBox' text='Log commands' \n" +
	"	   left='10'  top='208' width='170' height='16'  checked='false'/>\n" +
	"         <control name='chkAcceptLocal'    progid='DecalControls.CheckBox' text='Local chat summon commands' \n" +
	"	   left='10'  top='228' width='180' height='16'  checked='false'/>\n" +	
	"	</control>\n" +
	"       </page>\n";

    // Build list of character names
    szSchemaConfig4a = "";
    for (var x=0; x<skapi.cchar; x++) {
	szSchemaConfig4a += " <option data='" + x + "' text=\"" + skapi.rgszChar(x) + "\" />\n";
    } // end for
 
    szSchemaConfig4 =
	"	<page label='P2'>\n" +
	"	<control progid='DecalControls.FixedLayout'>\n" +
	"         <control name='portalChar'        progid='DecalControls.Choice' \n" +
	"          left='10'  top='8'   width='150' height='16' droplines='7' >\n" + szSchemaConfig4a +
	"         </control>\n" +

	"         <control name='HealSelfText'      progid='DecalControls.StaticText' text='Heal Self' \n" +
	"          left='10'  top='32'  width='55'  height='16' />\n" +
	"         <control name='healSelf'          progid='DecalControls.Choice' \n" +
	"          left='65'  top='32'  width='40'  height='16' droplines='7' >\n" + szSchemaSpellLevels +
	"         </control>\n" +
	"         <control name='S2MText'           progid='DecalControls.StaticText' text='Stam2Mana' \n" +
	"          left='115' top='32'  width='55'  height='16' />\n" +
	"         <control name='stam2mana'         progid='DecalControls.Choice' \n" +
	"          left='170' top='32'  width='40'  height='16' droplines='7' >\n" + szSchemaSpellLevels +
	"         </control>\n" +
	"         <control name='RevitText'         progid='DecalControls.StaticText' text='Revitalize' \n" +
	"          left='10'  top='52'  width='55'  height='16' />\n" +
	"         <control name='revitSelf'         progid='DecalControls.Choice' \n" +
	"          left='65'  top='52'  width='40'  height='16' droplines='7' >\n" + szSchemaSpellLevels +
	"         </control>\n" +
	"         <control name='StrengthText'      progid='DecalControls.StaticText' text='Strength' \n" +
	"          left='115' top='52'  width='55'  height='16' />\n" +
	"         <control name='strengthSelf'      progid='DecalControls.Choice' \n" +
	"          left='170' top='52'  width='40'  height='16' droplines='7' >\n" + szSchemaSpellLevels +
	"         </control>\n" +

	"         <control name='chkPrimEnabled'    progid='DecalControls.CheckBox'  text='Enable Primary' \n" +
	"          left='10'  top='80'  width='170' height='16' checked='false'/>\n" +
	"         <control name='text4a'            progid='DecalControls.StaticText' text='Keyword: ' \n" +
	"	   left='10'  top='100' width='45'  height='16' />\n" +
	"         <control name='text4av'           progid='DecalControls.StaticText' text='?' \n" +
	"	   left='60'  top='100' width='140' height='16' />\n" +
	"         <control name='editConfig4a'      progid='DecalControls.Edit' \n" +
	"	   left='60'  top='119' width='140' height='18' \n" +
	"	   marginx='12' marginy='2' imageportalsrc='4726' text='' />\n" +
	"         <control name='text4b'            progid='DecalControls.StaticText' text='Desc: ' \n" +
	"	   left='10'  top='140' width='45'  height='16' />\n" +
	"         <control name='text4bv'           progid='DecalControls.StaticText' text='?' \n" +
	"	   left='60'  top='140' width='140' height='16' />\n" +
	"         <control name='editConfig4b'      progid='DecalControls.Edit' \n" +
	"	   left='60'  top='159' width='140' height='18' \n" +
	"	   marginx='12' marginy='2' imageportalsrc='4726' text='' />\n" +

	"         <control name='chkSecEnabled'     progid='DecalControls.CheckBox'  text='Enable Secondary' \n" +
	"          left='10'  top='185' width='170' height='16' checked='false'/>\n" +
	"         <control name='text4e'            progid='DecalControls.StaticText' text='Keyword: ' \n" +
	"	   left='10'  top='205' width='45'  height='16' />\n" +
	"         <control name='text4ev'           progid='DecalControls.StaticText' text='?' \n" +
	"	   left='60'  top='205' width='140' height='16' />\n" +
	"         <control name='editConfig4e'      progid='DecalControls.Edit' \n" +
	"	   left='60'  top='224' width='140' height='18' \n" +
	"	   marginx='12' marginy='2' imageportalsrc='4726' text='' />\n" +
	"         <control name='text4f'            progid='DecalControls.StaticText' text='Desc: ' \n" +
	"	   left='10'  top='245' width='45'  height='16' />\n" +
	"         <control name='text4fv'           progid='DecalControls.StaticText' text='?' \n" +
	"	   left='60'  top='245' width='140' height='16' />\n" +
	"         <control name='editConfig4f'      progid='DecalControls.Edit' \n" +
	"	   left='60'  top='264' width='140' height='18' \n" +
	"	   marginx='12' marginy='2' imageportalsrc='4726' text='' />\n" +

	"	</control>\n" +
	"       </page>\n";

    szSchemaConfig5 =
	"	<page label='IS'>\n" +
	"	<control progid='DecalControls.FixedLayout'>\n" +
	"         <control name='textInfo1'         progid='DecalControls.StaticText' text='Info' \n" +
	"	   left='10'  top='8'   width='170' height='16' />\n" +
	"         <control name='chkChatSupport'    progid='DecalControls.CheckBox'  text='Support via local chat' \n" +
	"          left='10'  top='27'  width='170' height='16' checked='false'/>\n" +
	"         <control name='chkAllegSupport'   progid='DecalControls.CheckBox'  text='Support via @allegiance' \n" +
	"          left='10'  top='46'  width='170' height='16' checked='false'/>\n" +
	"         <control name='chkFriendSupport'  progid='DecalControls.CheckBox'  text='Support via @tell' \n" +
	"          left='10'  top='65'  width='170' height='16' checked='false'/>\n" +
	"         <control name='chkLogChat'        progid='DecalControls.CheckBox'  text='Log chat' \n" +
	"          left='10'  top='84'  width='170' height='16' checked='false'/>\n" +
	"         <control name='chkLogAlleg'       progid='DecalControls.CheckBox'  text='Log @allegiance' \n" +
	"          left='10'  top='103' width='170' height='16' checked='false'/>\n" +
	"         <control name='chkLogGen'         progid='DecalControls.CheckBox'  text='Log @general' \n" +
	"          left='10'  top='122'  width='170' height='16' checked='false'/>\n" +
	"         <control name='chkLogTrade'       progid='DecalControls.CheckBox'  text='Log @trade' \n" +
	"          left='10'  top='141' width='170' height='16' checked='false'/>\n" +
	"         <control name='chkRepPlayer'      progid='DecalControls.CheckBox'  text='Announce Players' \n" +
	"          left='10'  top='160' width='170' height='16' checked='false'/>\n" +
	"         <control name='chkVerbose'        progid='DecalControls.CheckBox'  text='Verbose' \n" +
	"          left='10'  top='179' width='170' height='16' checked='false'/>\n" +

	"         <control name='textStart1'        progid='DecalControls.StaticText' text='Startup' \n" +
	"	   left='10'  top='203' width='150' height='16' />\n" +
	"         <control name='chkStartSummon'    progid='DecalControls.CheckBox' text='Summoning enabled at start' \n" +
	"	   left='10'  top='222' width='150' height='16' checked='false'/>\n" +
	"         <control name='chkStartBuff'      progid='DecalControls.CheckBox' text='Buffing enabled at start' \n" +
	"	   left='10'  top='241' width='150' height='16' checked='false'/>\n" +
	"         <control name='chkStartFellow'    progid='DecalControls.CheckBox' text='Create fellowship at start' \n" +
	"	   left='10'  top='260' width='170' height='16' checked='false'/>\n" +

	"	</control>\n" +
	"       </page>\n";

    szSchemaConfig6 =
	"	<page label='CA'>\n" +
	"	<control progid='DecalControls.FixedLayout'>\n" +

	"         <control name='textComp1'         progid='DecalControls.StaticText' text='Components' \n" +
	"	   left='10'  top='8'   width='140' height='16' />\n" +
	"         <control name='chkComps'          progid='DecalControls.CheckBox'   text='Comp checking' \n" +
	"	   left='10'  top='28'  width='100' height='16'  checked='false'/>\n" +
	"         <control name='chkCompLog'        progid='DecalControls.CheckBox'   text='Low comp logging' \n" +
	"	   left='10'  top='46'  width='105' height='16'  checked='false'/>\n" +
	"         <control name='chkCompAssist'     progid='DecalControls.CheckBox'   text='Comp assist' \n" +
	"	   left='10'  top='64'  width='100' height='16'  checked='false'/>\n" +
	"         <control name='chkSplitPeas'      progid='DecalControls.CheckBox'   text='Split Peas' \n" +
	"	   left='10'  top='82'  width='100' height='16'  checked='false'/>\n" +

	"         <control name='textAlert1'        progid='DecalControls.StaticText' text='Alerting' \n" +
	"	   left='10'  top='106' width='140' height='16' />\n" +
	"         <control name='chkDeathAlert'     progid='DecalControls.CheckBox'   text='Death Alert' \n" +
	"          left='10'  top='128' width='130' height='16' checked='false'/>\n" +
	"         <control name='chkHideAlert'      progid='DecalControls.CheckBox'   text='Hide Alert' \n" +
	"          left='10'  top='148' width='130' height='16' checked='false'/>\n" +
	"         <control name='chkCompAlert'      progid='DecalControls.CheckBox'   text='Low Comp Alert' \n" +
	"          left='10'  top='168' width='130' height='16' checked='false'/>\n" +
	"         <control name='chkAbortAlert'     progid='DecalControls.CheckBox'   text='Abort Alert' \n" +
	"          left='10'  top='188' width='130' height='16' checked='false'/>\n" +
	"         <control name='btnTestAlert'      progid='DecalControls.PushButton' text='Test Alert' \n" +
	"          left='10'  top='208' width='110' height='20' />\n" +
	"	</control>\n" +
	"       </page>\n";

    szSchemaConfig7 =
	"	<page label='D'>\n" +
	"       <control progid='DecalControls.FixedLayout'>\n" +
	"         <control name='textDebug1'        progid='DecalControls.StaticText' text='Debugging' \n" +
	"	   left='10'  top='8'   width='160' height='18' />\n" +
	"         <control name='chkDebug'          progid='DecalControls.CheckBox'   text='Log General Debug Info' \n" +
	"	   left='10'  top='30'  width='160' height='18' checked='false'/>\n" +
	"         <control name='chkEvents'         progid='DecalControls.CheckBox'   text='Log Event Debug Info' \n" +
	"	   left='10'  top='50'  width='160' height='18' checked='false'/>\n" +
	"         <control name='chkStateDebug'     progid='DecalControls.CheckBox'   text='Log State Debug Info' \n" +
	"	   left='10'  top='70'  width='160' height='18' checked='false'/>\n" +
	"         <control name='chkIdleDebug'      progid='DecalControls.CheckBox'   text='Log Idle Debug Info' \n" +
	"	   left='10'  top='90'  width='160' height='18' checked='false'/>\n" +
	"         <control name='chkBuffDebug'      progid='DecalControls.CheckBox'   text='Log Buff Debug Info' \n" +
	"	   left='10'  top='110' width='160' height='18' checked='false'/>\n" +
	"         <control name='chkCastDebug'      progid='DecalControls.CheckBox'   text='Log Cast Debug Info' \n" +
	"	   left='10'  top='130' width='160' height='18' checked='false'/>\n" +
	"         <control name='chkSummonDebug'    progid='DecalControls.CheckBox'   text='Log Summon Debug Info' \n" +
	"	   left='10'  top='150' width='160' height='18' checked='false'/>\n" +
	"	</control>\n" +
	"       </page>\n";
	
    szSchemaConfig8 =
	"    </control>\n" +
	"  </control>\n" +
	"</view>";

    szSchemaConfig = szSchemaConfig1 + szSchemaConfig2 + szSchemaConfig3 + szSchemaConfig4 +
    		     szSchemaConfig5 + szSchemaConfig6 + szSchemaConfig7 + szSchemaConfig8;


    szSchemaBuff1 =
	"<view title='" + szPanelBuffs + "' iconlibrary='Inject.dll' icon='128' \n" +
	"  width='205' height='340'>\n" +
	"  <control progid='DecalControls.FixedLayout'>\n" +
	"    <control name='controlTab' progid='DecalControls.Notebook' " +
	"     left='0' top='0' width='205' height='340'>\n" +
	"	<page label='Gen'>\n" +
	"       <control progid='DecalControls.FixedLayout'>\n" +
	"         <control name='text1a'      progid='DecalControls.StaticText' text='Buff Configuration' \n" +
	"	   left='10'  top='8' width='140' height='20' />\n" +
	"         <control name='btnBuffLoad'     progid='DecalControls.PushButton' text='Load' \n" +
	"	   left='10'  top='30' width='75' height='18' />\n" +
	"         <control name='btnBuffSave'     progid='DecalControls.PushButton' text='Save' \n" +
	"	   left='10'  top='50' width='75' height='18' />\n" +
	"         <control name='btnBuffReset'      progid='DecalControls.PushButton' text='Reset' \n" +
	"	   left='10'  top='70'  width='75'  height='18' />\n" +
	"         <control name='btnBuffShow'       progid='DecalControls.PushButton' text='Show Enabled' \n" +
	"	   left='10'  top='90' width='75'   height='18' />\n" +
	"	</control>\n" +
	"       </page>\n";

    szSchemaBuff2 =
	"	<page label='Cre'>\n" +
	"       <control progid='DecalControls.FixedLayout'>\n" +
	"         <control name='creChoice'         progid='DecalControls.Choice' \n" +
	"	   left='10'  top='10' width='185'  height='20' >\n";

    szSchemaBuff2a = "";
    for (var x=Buff[AccCurChar].Range[buffTypeCre].Begin; x<=Buff[AccCurChar].Range[buffTypeCre].End; x++)
	    szSchemaBuff2a += "  <option data='" + x + "' text='" + Buff[AccCurChar].Info[x].Name + "'/>\n";

    szSchemaBuff2 += szSchemaBuff2a +
	"         </control>\n" +
	"         <control name='chkBuffCreEnab'    progid='DecalControls.CheckBox'  text='Enabled' \n" +
	"	   left='15'  top='38' width='60'   height='18'  checked='false'/>\n" +
	"         <control name='chkBuffCreRandom'  progid='DecalControls.CheckBox'  text='Randomize' \n" +
	"	   left='110' top='38' width='70'   height='18'  checked='false'/>\n" +

	"         <control name='text2b'            progid='DecalControls.StaticText' text='Level: ' \n" +
	"	   left='15'  top='58'  width='45'  height='16' />\n" +
	"         <control name='choiceBuff2b'      progid='DecalControls.Choice' \n" +
	"	   left='65'  top='57'  width='50'  height='18' >\n" + szSchemaSpellLevels +
  	"         </control>\n" +
	"         <control name='text2c'            progid='DecalControls.StaticText' text='Safety: ' \n" +
	"	   left='15'  top='78'  width='45'  height='16' />\n" +
	"         <control name='text2cv'           progid='DecalControls.StaticText' text='?' \n" +
	"	   left='70'  top='78'  width='45'  height='16' />\n" +
	"         <control name='editBuff2c'        progid='DecalControls.Edit' \n" +
	"	   left='110' top='77'  width='75'  height='18' \n" +
	"	   marginx='12' marginy='2' imageportalsrc='4726' text='' />\n" +

	"         <control name='text2d'            progid='DecalControls.StaticText' text='Priority: ' \n" +
	"	   left='15'  top='98'  width='45'  height='16' />\n" +
	"         <control name='text2dv'           progid='DecalControls.StaticText' text='?' \n" +
	"	   left='70'  top='98'  width='45'  height='16' />\n" +
	"         <control name='editBuff2d'         progid='DecalControls.Edit' \n" +
	"	   left='110' top='97'  width='75'  height='18' \n" +
	"	   marginx='12' marginy='2' imageportalsrc='4726' text='' />\n" +

	"         <control name='btnBuffCreNext'    progid='DecalControls.PushButton'  text='Next' \n" +
	"	   left='15'  top='120' width='75'  height='18' />\n" +
	"         <control name='btnBuffCrePrev'    progid='DecalControls.PushButton'  text='Prev' \n" +
	"	   left='110' top='120' width='75'  height='18' />\n" +
	"         <control name='btnBuffCreSetPrev' progid='DecalControls.PushButton'  text='Set as Prev' \n" +
	"	   left='15'  top='142' width='75'  height='18' />\n" +
	"         <control name='btnBuffCreSetLast' progid='DecalControls.PushButton'  text='Set as Last' \n" +
	"	   left='110' top='142' width='75'  height='18' />\n" +
	"         <control name='btnBuffCreShow'    progid='DecalControls.PushButton'  text='Show Enabled' \n" +
	"	   left='15'  top='164' width='75'  height='18' />\n" +
	"         <control name='btnBuffCreAll'     progid='DecalControls.PushButton'  text='All Like This' \n" +
	"	   left='110' top='164' width='75'  height='18' />\n" +

	"	</control>\n" +
	"       </page>\n";

   szSchemaBuff3 =
	"	<page label='Life'>\n" +
	"       <control progid='DecalControls.FixedLayout'>\n" +
	"         <control name='lifeChoice'        progid='DecalControls.Choice' \n" +
	"	   left='10'  top='10' width='185'  height='20' >\n";

    szSchemaBuff3a = "";
    for (var x=Buff[AccCurChar].Range[buffTypeLife].Begin; x<=Buff[AccCurChar].Range[buffTypeLife].End; x++)
	    szSchemaBuff3a += " <option data='" + x + "' text='" + Buff[AccCurChar].Info[x].Name + "'/>\n";

    szSchemaBuff3 += szSchemaBuff3a +
	"         </control>\n" +
	"         <control name='chkBuffLifeEnab'   progid='DecalControls.CheckBox'  text='Enabled' \n" +
	"	   left='15'  top='38' width='60'   height='18'  checked='false'/>\n" +
	"         <control name='chkBuffLifeRandom' progid='DecalControls.CheckBox'  text='Randomize' \n" +
	"	   left='110' top='38' width='70'   height='18'  checked='false'/>\n" +

	"         <control name='text3b'            progid='DecalControls.StaticText' text='Level: ' \n" +
	"	   left='15'  top='58'  width='45'  height='16' />\n" +
	"         <control name='choiceBuff3b'      progid='DecalControls.Choice' \n" +
	"	   left='65'  top='57'  width='50'  height='18' >\n" + szSchemaSpellLevels +
  	"         </control>\n" +
	"         <control name='text3c'            progid='DecalControls.StaticText' text='Safety: ' \n" +
	"	   left='15'  top='78'  width='45'  height='16' />\n" +
	"         <control name='text3cv'           progid='DecalControls.StaticText' text='?' \n" +
	"	   left='70'  top='78'  width='45'  height='16' />\n" +
	"         <control name='editBuff3c'        progid='DecalControls.Edit' \n" +
	"	   left='110' top='77'  width='75'  height='18' \n" +
	"	   marginx='12' marginy='2' imageportalsrc='4726' text='' />\n" +

	"         <control name='text3d'            progid='DecalControls.StaticText' text='Priority: ' \n" +
	"	   left='15'  top='98'  width='45'  height='16' />\n" +
	"         <control name='text3dv'           progid='DecalControls.StaticText' text='?' \n" +
	"	   left='70'  top='98'  width='45'  height='16' />\n" +
	"         <control name='editBuff3d'        progid='DecalControls.Edit' \n" +
	"	   left='110' top='97'  width='75'  height='18' \n" +
	"	   marginx='12' marginy='2' imageportalsrc='4726' text='' />\n" +

	"         <control name='btnBuffLifeNext'    progid='DecalControls.PushButton'  text='Next' \n" +
	"	   left='15'  top='120' width='75'   height='18' />\n" +
	"         <control name='btnBuffLifePrev'    progid='DecalControls.PushButton'  text='Prev' \n" +
	"	   left='110' top='120' width='75'   height='18' />\n" +
	"         <control name='btnBuffLifeSetPrev' progid='DecalControls.PushButton'  text='Set as Prev' \n" +
	"	   left='15'  top='142' width='75'   height='18' />\n" +
	"         <control name='btnBuffLifeSetLast' progid='DecalControls.PushButton'  text='Set as Last' \n" +
	"	   left='110' top='142' width='75'   height='18' />\n" +
	"         <control name='btnBuffLifeShow'    progid='DecalControls.PushButton'  text='Show Enabled' \n" +
	"	   left='15'  top='164' width='75'   height='18' />\n" +
	"         <control name='btnBuffLifeAll'     progid='DecalControls.PushButton'  text='All Like This' \n" +
	"	   left='110' top='164' width='75'   height='18' />\n" +
	"	</control>\n" +
	"       </page>\n";

   szSchemaBuff4 =
	"	<page label='Armor'>\n" +
	"       <control progid='DecalControls.FixedLayout'>\n" +
	"         <control name='armorChoice'       progid='DecalControls.Choice' \n" +
	"	   left='10'  top='10' width='185'  height='20' >\n";

    szSchemaBuff4a = "";
    for (var x=0; x<Buff[AccCurChar].InfoCnt; x++)
	if ((Buff[AccCurChar].Info[x].Type == buffTypeItem) && (Buff[AccCurChar].Info[x].Class == equipClassArmor))
	    szSchemaBuff4a += "  <option data='" + x + "' text='" + Buff[AccCurChar].Info[x].Name + "'/>\n";

    szSchemaBuff4 += szSchemaBuff4a +
	"         </control>\n" +
	"         <control name='chkBuffArmorEnab'   progid='DecalControls.CheckBox'  text='Enabled' \n" +
	"	   left='15'  top='38' width='60'    height='18'  checked='false'/>\n" +
	"         <control name='chkBuffArmorRandom' progid='DecalControls.CheckBox'  text='Randomize' \n" +
	"	   left='110' top='38' width='70'    height='18'  checked='false'/>\n" +

	"         <control name='text4b'             progid='DecalControls.StaticText' text='Level: ' \n" +
	"	   left='15'  top='58'  width='45'   height='16' />\n" +
	"         <control name='choiceBuff4b'       progid='DecalControls.Choice' \n" +
	"	   left='65'  top='57'  width='50'   height='18' >\n" + szSchemaSpellLevels +
  	"         </control>\n" +

	"         <control name='text4c'             progid='DecalControls.StaticText' text='Safety: ' \n" +
	"	   left='15'  top='78'  width='45'   height='16' />\n" +
	"         <control name='text4cv'            progid='DecalControls.StaticText' text='?' \n" +
	"	   left='70'  top='78'  width='45'   height='16' />\n" +
	"         <control name='editBuff4c'         progid='DecalControls.Edit' \n" +
	"	   left='110' top='77'  width='75'   height='18' \n" +
	"	   marginx='12' marginy='2' imageportalsrc='4726' text='' />\n" +

	"         <control name='text4d'             progid='DecalControls.StaticText' text='Priority: ' \n" +
	"	   left='15'  top='98'  width='45'   height='16' />\n" +
	"         <control name='text4dv'            progid='DecalControls.StaticText' text='?' \n" +
	"	   left='70'  top='98'  width='45'   height='16' />\n" +
	"         <control name='editBuff4d'         progid='DecalControls.Edit' \n" +
	"	   left='110' top='97' width='75'    height='18' \n" +
	"	   marginx='12' marginy='2' imageportalsrc='4726' text='' />\n" +

	"         <control name='chkPaperDoll'       progid='DecalControls.CheckBox' \n" +
	"	   text='Paper Doll (suppresses options below)' \n" +
	"	   left='5'   top='122' width='200'  height='18'  checked='false'/>\n" +

	"         <control name='chkBuffHead'        progid='DecalControls.CheckBox'  text='Head' \n" +
	"	   left='5'   top='142' width='50'   height='18'  checked='false'/>\n" +
	"         <control name='chkBuffHands'       progid='DecalControls.CheckBox'  text='Hands' \n" +
	"	   left='5'   top='162' width='50'   height='18'  checked='false'/>\n" +
	"         <control name='chkBuffFeet'        progid='DecalControls.CheckBox'  text='Feet' \n" +
	"	   left='5'   top='182' width='50'   height='18'  checked='false'/>\n" +

	"         <control name='chkBuffChest'       progid='DecalControls.CheckBox'  text='Chest' \n" +
	"	   left='65'  top='142' width='65'   height='18'  checked='false'/>\n" +
	"         <control name='chkBuffUpArms'      progid='DecalControls.CheckBox'  text='UpArms' \n" +
	"	   left='65'  top='162' width='65'   height='18'  checked='false'/>\n" +
	"         <control name='chkBuffLowArms'     progid='DecalControls.CheckBox'  text='LowArms' \n" +
	"	   left='65'  top='182' width='65'   height='18'  checked='false'/>\n" +

	"         <control name='chkBuffAbdomen'     progid='DecalControls.CheckBox'  text='Abdomen' \n" +
	"	   left='140' top='142' width='60'   height='18'  checked='false'/>\n" +
	"         <control name='chkBuffUpLegs'      progid='DecalControls.CheckBox'  text='UpLegs' \n" +
	"	   left='140' top='162' width='60'   height='18'  checked='false'/>\n" +
	"         <control name='chkBuffLowLegs'     progid='DecalControls.CheckBox'  text='LowLegs' \n" +
	"	   left='140' top='182' width='60'   height='18'  checked='false'/>\n" +

	"         <control name='chkBuffShirt'       progid='DecalControls.CheckBox'  text='Shirt' \n" +
	"	   left='5'   top='202' width='50'   height='18'  checked='false'/>\n" +
	"         <control name='chkBuffPants'       progid='DecalControls.CheckBox'  text='Pants' \n" +
	"	   left='65'  top='202' width='55'   height='18'  checked='false'/>\n" +

	"         <control name='btnBuffArmorNext'    progid='DecalControls.PushButton'  text='Next' \n" +
	"	   left='15'  top='225' width='75'    height='18' />\n" +
	"         <control name='btnBuffArmorPrev'    progid='DecalControls.PushButton'  text='Prev' \n" +
	"	   left='110' top='225' width='75'    height='18' />\n" +
	"         <control name='btnBuffArmorSetPrev' progid='DecalControls.PushButton'  text='Set as Prev' \n" +
	"	   left='15'  top='247' width='75'    height='18' />\n" +
	"         <control name='btnBuffArmorSetLast' progid='DecalControls.PushButton'  text='Set as Last' \n" +
	"	   left='110' top='247' width='75'    height='18' />\n" +
	"         <control name='btnBuffArmorShow'    progid='DecalControls.PushButton'  text='Show Enabled' \n" +
	"	   left='15'  top='269' width='75'    height='18' />\n" +
	"         <control name='btnBuffArmorAll'     progid='DecalControls.PushButton'  text='All Like This' \n" +
	"	   left='110' top='269' width='75'    height='18' />\n" +
	"	</control>\n" +
	"       </page>\n";

  szSchemaBuff5 =
	"	<page label='Wands'>\n" +
	"       <control progid='DecalControls.FixedLayout'>\n" +

	"         <control name='text1a2'           progid='DecalControls.StaticText' text='Hermetic Link' \n" +
	"	   left='10'  top='10'  width='140' height='18' />\n" +

	"         <control name='chkBuffHermEnab'       progid='DecalControls.CheckBox'  text='Enabled' \n" +
	"	   left='15'  top='30'  width='60'  height='18'  checked='false'/>\n" +
	"         <control name='chkBuffHermRandom' progid='DecalControls.CheckBox'  text='Randomize' \n" +
	"	   left='110' top='30'  width='70'   height='18'  checked='false'/>\n" +

	"         <control name='text1b'            progid='DecalControls.StaticText' text='Level: ' \n" +
	"	   left='15'  top='50' width='45'  height='16' />\n" +
	"         <control name='choiceBuff1b'      progid='DecalControls.Choice' \n" +
	"	   left='65'  top='49' width='50'  height='18' >\n" + szSchemaSpellLevels +
  	"         </control>\n" +

	"         <control name='text1c'            progid='DecalControls.StaticText' text='Safety: ' \n" +
	"	   left='15'  top='70'  width='45'  height='16' />\n" +
	"         <control name='text1cv'           progid='DecalControls.StaticText' text='?' \n" +
	"	   left='70'  top='70'  width='45'  height='16' />\n" +
	"         <control name='editBuff1c'        progid='DecalControls.Edit' \n" +
	"	   left='110' top='69'  width='75'  height='18' \n" +
	"	   marginx='12' marginy='2' imageportalsrc='4726' text='' />\n" +

	"         <control name='text1d'            progid='DecalControls.StaticText' text='Priority: ' \n" +
	"	   left='15'  top='90' width='45'   height='16' />\n" +
	"         <control name='text1dv'           progid='DecalControls.StaticText' text='?' \n" +
	"	   left='70'  top='90' width='45'   height='16' />\n" +
	"         <control name='editBuff1d'        progid='DecalControls.Edit' \n" +
	"	   left='110' top='89' width='75'   height='18' \n" +
	"	   marginx='12' marginy='2' imageportalsrc='4726' text='' />\n" +

	"         <control name='text5a1' progid='DecalControls.StaticText' text='________________________________' \n" +
	"	   left='5'   top='110' width='200' height='20' />\n" +

	"         <control name='text5a2'           progid='DecalControls.StaticText' text='Defender' \n" +
	"	   left='10'  top='130' width='140' height='18' />\n" +

	"         <control name='chkBuffDefEnab'    progid='DecalControls.CheckBox'  text='Enabled' \n" +
	"	   left='15'  top='150'  width='60' height='18'  checked='false'/>\n" +
	"         <control name='chkBuffDefRandom'  progid='DecalControls.CheckBox'  text='Randomize' \n" +
	"	   left='110' top='150'  width='70' height='18'  checked='false'/>\n" +

	"         <control name='text5b'            progid='DecalControls.StaticText' text='Level: ' \n" +
	"	   left='15'  top='170' width='45'  height='16' />\n" +
	"         <control name='choiceBuff5b'      progid='DecalControls.Choice' \n" +
	"	   left='65'  top='169' width='50'  height='18' >\n" + szSchemaSpellLevels +
  	"         </control>\n" +

	"         <control name='text5c'            progid='DecalControls.StaticText' text='Safety: ' \n" +
	"	   left='15'  top='190'  width='45' height='16' />\n" +
	"         <control name='text5cv'           progid='DecalControls.StaticText' text='?' \n" +
	"	   left='70'  top='190'  width='45' height='16' />\n" +
	"         <control name='editBuff5c'        progid='DecalControls.Edit' \n" +
	"	   left='110' top='189'  width='75' height='18' \n" +
	"	   marginx='12' marginy='2' imageportalsrc='4726' text='' />\n" +

	"         <control name='text5d'            progid='DecalControls.StaticText' text='Priority: ' \n" +
	"	   left='15'  top='210' width='45'  height='16' />\n" +
	"         <control name='text5dv'           progid='DecalControls.StaticText' text='?' \n" +
	"	   left='70'  top='210' width='45'  height='16' />\n" +
	"         <control name='editBuff5d'        progid='DecalControls.Edit' \n" +
	"	   left='110' top='209' width='75'  height='18' \n" +
	"	   marginx='12' marginy='2' imageportalsrc='4726' text='' />\n" +

	"	</control>\n" +
	"       </page>\n";

    szSchemaBuff6 =
	"    </control>\n" +
	"  </control>\n" +
	"</view>";

    szSchemaBuffs = szSchemaBuff1 + szSchemaBuff2 + szSchemaBuff3 + szSchemaBuff4 + szSchemaBuff5 + szSchemaBuff6;


    szSchemaComp1 =
	"<view title='" + szPanelComps + "' iconlibrary='Inject.dll' icon='128' \n" +
	"  width='190' height='325'>\n" +
	"  <control progid='DecalControls.FixedLayout'>\n";

    szSchemaComp2 =
	"    <control name='textGen'             progid='DecalControls.StaticText' text='Component Management' \n" +
	"	left='10'  top='8'   width='140' height='18' />\n" +
	"    <control name='btnCompLoad'         progid='DecalControls.PushButton' text='Load' \n" +
	"	left='10'  top='25'  width='60'  height='18' />\n" +
	"    <control name='btnCompReset'        progid='DecalControls.PushButton' text='Reset' \n" +
	"	left='75'  top='25'  width='60'  height='18' />\n" +
	"    <control name='btnCompSave'         progid='DecalControls.PushButton' text='Save' \n" +
	"	left='10'  top='47'  width='60'  height='18' />\n";


    szSchemaComp3a = "";
    for (var x=0; x<Comp[AccCurChar].Count; x++)
	szSchemaComp3a = szSchemaComp3a + "  <option data='" + x + "' text='" + Comp[AccCurChar].Info[x].Name + "'/>\n";

    szSchemaComp3 =
	"    <control name='compChoice'          progid='DecalControls.Choice' \n" +
	"	left='10'  top='90'  width='170' height='20' >\n" +  szSchemaComp3a +
	"    </control>\n" +

	"    <control name='chkCompEnabled'    progid='DecalControls.CheckBox'  text='Enabled' \n" +
	"	left='10'  top='115' width='125' height='18'  checked='false'/>\n" +

	"    <control name='textComp1'         progid='DecalControls.StaticText' text='Warn Lvl:' \n" +
	"	left='10'  top='135' width='60'  height='16' />\n" +
	"    <control name='textComp1v'        progid='DecalControls.StaticText' text='?' \n" +
	"	left='75'  top='135' width='30'  height='16' />\n" +
	"    <control name='editComp1'         progid='DecalControls.Edit' \n" +
	"	left='115' top='134' width='60'  height='18' \n" +
	"	marginx='12' marginy='2' imageportalsrc='4726' text='' />\n" +

	"    <control name='textComp2'         progid='DecalControls.StaticText' text='Split Lvl:' \n" +
	"	left='10'  top='155' width='60'  height='16' />\n" +
	"    <control name='textComp2v'         progid='DecalControls.StaticText' text='?' \n" +
	"	left='75'  top='155' width='30'  height='16' />\n" +
	"    <control name='editComp2'         progid='DecalControls.Edit' \n" +
	"	left='115' top='154' width='60'  height='18' \n" +
	"	marginx='12' marginy='2' imageportalsrc='4726' text='' />\n" +

	"    <control name='textComp3'         progid='DecalControls.StaticText' text='Crit Lvl:' \n" +
	"	left='10'  top='175' width='60'  height='16' />\n" +
	"    <control name='textComp3v'        progid='DecalControls.StaticText' text='?' \n" +
	"	left='75'  top='175' width='30'  height='16' />\n" +
	"    <control name='editComp3'         progid='DecalControls.Edit' \n" +
	"	left='115' top='174' width='60'  height='18' \n" +
	"	marginx='12' marginy='2' imageportalsrc='4726' text='' />\n" +

	"    <control name='textComp4'         progid='DecalControls.StaticText' text='Buy Lvl:' \n" +
	"	left='10'  top='195' width='60'  height='16' />\n" +
	"    <control name='textComp4v'        progid='DecalControls.StaticText' text='?' \n" +
	"	left='75'  top='195' width='30'  height='16' />\n" +
	"    <control name='editComp4'         progid='DecalControls.Edit' \n" +
	"	left='115' top='194' width='60'  height='18' \n" +
	"	marginx='12' marginy='2' imageportalsrc='4726' text='' />\n" +

	"    <control name='btnCompNext'       progid='DecalControls.PushButton'  text='Next' \n" +
	"	left='10'  top='220' width='75'  height='18' />\n" +
	"    <control name='btnCompPrev'       progid='DecalControls.PushButton'  text='Prev' \n" +
	"	left='105' top='220' width='75'  height='18' />\n" +
	"    <control name='btnCompSetAs'      progid='DecalControls.PushButton'  text='Set as Prev' \n" +
	"	left='10'  top='240' width='75'  height='18' />\n" +
	"    <control name='btnCompReset'      progid='DecalControls.PushButton'  text='Reset All' \n" +
	"	left='105' top='240' width='75'  height='18' />\n" +
	"    <control name='btnCompShow'       progid='DecalControls.PushButton'  text='Show Enabled' \n" +
	"	left='10'  top='260' width='75'  height='18' />\n";

    szSchemaComp4 =
	"  </control>\n" +
	"</view>";

    szSchemaComps =  szSchemaComp1 + szSchemaComp2 + szSchemaComp3 + szSchemaComp4;

} // end function


// Display interface
function DisplayInterface() {
    //	Put up the control panels in a minimized state
    skapi.ShowControls(szSchemaControl, false);
    skapi.ShowControls(szSchemaConfig,  false);
    skapi.ShowControls(szSchemaBuffs,   false);
    skapi.ShowControls(szSchemaComps,   false);

    // Now set the text values on some of the buttons and checkboxes based on user defined configuration variables
    SetGenControls();
    SetBuffControls();
    SetCompControls();

    // Process events so that any updates to the decal panels are processed immediately
    skapi.WaitEvent(100, wemFullTimeout);
    return;
} // end function


// Remove decal-like interface
function RemoveInterface() {
    // Take down the panels
    skapi.RemoveControls(szPanelControl);
    skapi.RemoveControls(szPanelConfig);
    skapi.RemoveControls(szPanelBuffs);
    skapi.RemoveControls(szPanelComps);
    return;
} // end function


function SetCompControls() {
    skapi.SetControlProperty(szPanelComps, "compChoice", "selected",  0);
} // end func


function SetBuffControls() {
    BuffHermIndex = Buff[AccCurChar].Lookup("Hermetic Link");
    DisplayBuffHerm();
    BuffDefIndex  = Buff[AccCurChar].Lookup("Defender");
    DisplayBuffDef();
    skapi.SetControlProperty(szPanelBuffs, "creChoice", "selected", 0);
    DisplayBuffCre(Buff[AccCurChar].Range[buffTypeCre].Begin);
    skapi.SetControlProperty(szPanelBuffs, "lifeChoice", "selected", 0);
    DisplayBuffLife(Buff[AccCurChar].Range[buffTypeLife].Begin);
    skapi.SetControlProperty(szPanelBuffs, "armorChoice", "selected", 0);
    DisplayBuffArmor(Buff[AccCurChar].Range[buffTypeItem].Begin);
} // end func


// Set general controls based on macro control variables
function SetGenControls() {
    if (SummonMode)	skapi.SetControlProperty(szPanelControl, "btnSummonMode", "Text", "Disable Summoning"  );
    if (BuffMode)	skapi.SetControlProperty(szPanelControl, "btnBuffMode",   "Text", "Disable Buffing"  );

    // General 1 tab
    skapi.SetControlProperty(szPanelConfig, "chkCreatureHide",	 "checked",  flagCreatureLog	);
    skapi.SetControlProperty(szPanelConfig, "chkCreatureWarn",	 "checked",  flagCreatureWarn	);
    skapi.SetControlProperty(szPanelConfig, "chkDeathLog",	 "checked",  flagDeathLog	);
    skapi.SetControlProperty(szPanelConfig, "chkDamageLog",	 "checked",  flagDamageLog	);
    skapi.SetControlProperty(szPanelConfig, "chkReduceBurden",	 "checked",  flagReduceBurden	);
    skapi.SetControlProperty(szPanelConfig, "chkAutoResume",	 "checked",  flagAutoResume	);
    skapi.SetControlProperty(szPanelConfig, "chkWarAvoid",	 "checked",  flagWarAvoid	);
    skapi.SetControlProperty(szPanelConfig, "chkSlideCast",	 "checked",  flagSlideCast	);
    skapi.SetControlProperty(szPanelConfig, "chkRespondWhere",	 "checked",  flagRespondWhere	);

    // Portal 1 tab
    skapi.SetControlProperty(szPanelConfig, "chkCloseBy",	 "checked",  flagCloseOnly	);
    skapi.SetControlProperty(szPanelConfig, "chkPortalGems",	 "checked",  flagPortalGems	);
    skapi.SetControlProperty(szPanelConfig, "chkAutoRotate",	 "checked",  flagAutoRotate	);
    skapi.SetControlProperty(szPanelConfig, "chkAvoidStorms",	 "checked",  flagStormAvoid	);
    skapi.SetControlProperty(szPanelConfig, "chkAdvertise",	 "checked",  flagAdvertise	);
    skapi.SetControlProperty(szPanelConfig, "chkOpenMsg",	 "checked",  flagOpenMsg	);
    skapi.SetControlProperty(szPanelConfig, "chkAckGifts",	 "checked",  flagAckGifts	);
    skapi.SetControlProperty(szPanelConfig, "chkLogGifts",	 "checked",  flagLogGifts	);
    skapi.SetControlProperty(szPanelConfig, "chkLogStats",	 "checked",  flagLogStats	);
    skapi.SetControlProperty(szPanelConfig, "chkLogCmds",	 "checked",  flagLogCmds	);
    skapi.SetControlProperty(szPanelConfig, "chkAcceptLocal",    "checked",  flagAcceptLocal	);

    // Portal 2 tab
    skapi.SetControlProperty(szPanelConfig, "portalChar", "selected", 0);
    DisplayConfigPortal(0);

    // Info
    skapi.SetControlProperty(szPanelConfig, "chkChatSupport",	 "checked",  flagChatSup	);
    skapi.SetControlProperty(szPanelConfig, "chkAllegSupport",   "checked",  flagAllegSup	);
    skapi.SetControlProperty(szPanelConfig, "chkFriendSupport",	 "checked",  flagFriendSup	);
    skapi.SetControlProperty(szPanelConfig, "chkLogChat",	 "checked",  flagLogChat	);
    skapi.SetControlProperty(szPanelConfig, "chkLogAlleg",	 "checked",  flagLogAlleg	);
    
    skapi.SetControlProperty(szPanelConfig, "chkLogGen",	 "checked",  flagLogGeneral	);
    skapi.SetControlProperty(szPanelConfig, "chkLogTrade",	 "checked",  flagLogTrade	);
    
    skapi.SetControlProperty(szPanelConfig, "chkRepPlayer",	 "checked",  flagReportPlayer	);
    skapi.SetControlProperty(szPanelConfig, "chkVerbose",	 "checked",  flagVerbose	);

    // Start
    skapi.SetControlProperty(szPanelConfig, "chkStartBuff",	 "checked",  startBuffMode	);
    skapi.SetControlProperty(szPanelConfig, "chkStartSummon",	 "checked",  startSummonMode	);
    skapi.SetControlProperty(szPanelConfig, "chkStartFellow",	 "checked",  creFellow		);

    // Comps
    skapi.SetControlProperty(szPanelConfig, "chkComps",		 "checked",  flagCompCheck	);
    skapi.SetControlProperty(szPanelConfig, "chkCompLog",	 "checked",  flagCompLogOff	);
    skapi.SetControlProperty(szPanelConfig, "chkCompAssist",	 "checked",  flagCompAssist	);
    skapi.SetControlProperty(szPanelConfig, "chkSplitPeas",	 "checked",  flagSplitPeas	);

    // Alerts
    skapi.SetControlProperty(szPanelConfig, "chkDeathAlert",  	 "checked",  alertDeath		);
    skapi.SetControlProperty(szPanelConfig, "chkHideAlert",	 "checked",  alertHide		);
    skapi.SetControlProperty(szPanelConfig, "chkCompAlert",   	 "checked",  alertComps		);
    skapi.SetControlProperty(szPanelConfig, "chkAbortAlert",  	 "checked",  alertAbort		);

    // Debug
    skapi.SetControlProperty(szPanelConfig, "chkDebug",		 "checked",  debug		);
    skapi.SetControlProperty(szPanelConfig, "chkEvents",	 "checked",  debugEvent		);
    skapi.SetControlProperty(szPanelConfig, "chkStateDebug",	 "checked",  debugState		);
    skapi.SetControlProperty(szPanelConfig, "chkIdleDebug",	 "checked",  debugIdle		);
    skapi.SetControlProperty(szPanelConfig, "chkBuffDebug",	 "checked",  debugBuffs		);
    skapi.SetControlProperty(szPanelConfig, "chkCastDebug",	 "checked",  debugCast		);
    skapi.SetControlProperty(szPanelConfig, "chkSummonDebug",	 "checked",  debugSummon	);
} // end func