// DIB_EVENTS.JS
//
// Author:	Maud-Dib
// Version:	2.06
//
// Modification History
//
// Who	  Date	    Version	Description
//
// MD	  06/23/02  1.01	Initial version
//
//
// Description:
//
//	The following file contains all the event functions for PortalBot
//

// Event functions

// OnActionComplete
function MainHandlers_OnActionComplete() {
    if (debugEvent) Log.OutD("Main_OnActionComplete: Begin" );
    ActionComplete = true;
    if (debugEvent) Log.OutD("Main_OnActionComplete: End" );
} // end funct


function MainHandlers_OnChatBoxMessage(szMsg, cmc) {
    // Log.OutD("OnChatBoxMessage: szMsg [" + szMsg + "] length [" + szMsg.length + "] cmc [" + cmc + "]", true);
    
    // Strip last char off message which is the newline char
    var MsgLen = szMsg.length - 1;
    var Msg    = szMsg.substr(0,MsgLen);

    // Look for 'You must wait 28s before communicating again!' type messages.
    // If detected, then set a flag to suspend chat for a bit.
    // Log.OutD("OnChatBoxMessage: Msg [" + Msg + "]");
    var Pattern1 = new RegExp ( "^You must wait .* before communicating again!$", "g" );
    if (Pattern1.test(Msg)) {
    	// Log.OutD("OnChatBoxMessage: pattern matched, extracting time...");
	// Pattern found, extract the time we must wait
	var Pattern2 = new RegExp("(^You must wait | before communicating again.*)", "g" );
	var Time = Msg.replace(Pattern2, "");		// extract the time
	Log.OutD("OnChatBoxMessage: You must wait until communicating again.  Time [" + Time + "]");
	Chat.SetSilent(Time);
    } // endif

    // Log.OutD("OnChatBoxMessage: flagLogAlleg [" + flagLogAlleg + "] flagRespondWhere [" + flagRespondWhere + "]");
    // Log.OutD("OnChatBoxMessage: Msg.substr(0,12)  [" + Msg.substr(0,12)  + "]");
    if ((flagLogAlleg || flagRespondWhere) && (Msg.substr(0,12) == "[Allegiance]")) {
	if (flagLogAlleg) {
	    // Log.OutD("OnChatBoxMessage: Alleg: [" + Msg.substr(13) + "]");
	    // Alleg: <Tell:IIDString:0:Total Domination>Total Domination<\Tell> says, "greenspire
	    var Msg2 = Msg.substr(13);
	    var Pattern3 = new RegExp("<.Tell>", "g" );
	    var Msg3 = Msg2.replace(Pattern3, "");
	    var Pattern4 = new RegExp("<Tell.*>", "g" );
	    var Msg4 = Msg3.replace(Pattern4, "");
	    ChatLog.WriteLineD("Alleg: " + Msg4 + "\"");
	} // endif
	if (flagRespondWhere) {
	    var MsgUp = szMsg.toUpperCase();
	    if (MsgUp.indexOf("!WHERETO") >= 0) {
		ListPortals("ALLEG");
	    } // endif
	} // endif
    } // endif

    if ((flagLogGeneral) && (Msg.substr(0,9) == "[General]")) {
	var Msg2 = Msg.substr(10);
	var Pattern3 = new RegExp("<.Tell>", "g" );
	var Msg3 = Msg2.replace(Pattern3, "");
	var Pattern4 = new RegExp("<Tell.*>", "g" );
	var Msg4 = Msg3.replace(Pattern4, "");
	ChatLog.WriteLineD("Gen:   " + Msg4 + "\"");
	if (flagRespondWhere) {
	    var MsgUp = szMsg.toUpperCase();
	    if (MsgUp.indexOf("!WHERETO") >= 0) {
	    	if ((new Date() - lastWhereto) >= wheretoHolddown)
	    	{
		    lastWhereto = new Date()
		    ListPortals("GENERAL");
		} // endif
	    } //endif
	} // endif
    } // endif

    if ((flagLogTrade  ) && (Msg.substr(0,7) == "[Trade]")) {
	var Msg2 = Msg.substr(8);
	var Pattern3 = new RegExp("<.Tell>", "g" );
	var Msg3 = Msg2.replace(Pattern3, "");
	var Pattern4 = new RegExp("<Tell.*>", "g" );
	var Msg4 = Msg3.replace(Pattern4, "");
	ChatLog.WriteLineD("Trade: " + Msg4 + "\"");
    } // endif
} // end func


// OnChatBroadcast
function MainHandlers_OnChatBroadcast(acoSender, szMsg, cmc) {
    if (debugEvent) Log.OutD("Main_OnChatBroadcast: Begin, From [" + acoSender.szName + "] Msg [" + szMsg + "]");

    Name = acoSender.szName;

    if (logChat) Log.OutD( "ChatBroadcast: " + Util.Pad(acoSender.szName,20)+ " " + szMsg );
} // end func

// OnChatLocal
function MainHandlers_OnChatLocal(acoSender, msg) {
    if (debugEvent||debugCmds)
	Log.OutD("Main_OnChatLocal: Begin, Id [" + Util.Hex(acoSender.oid) + "] Sender [" +
		  acoSender.szName + "] msg [" + msg + ")", true );

    Name = acoSender.szName;
    if (logChat||debugCmds) Log.OutD( "OnChatLocal: Who [" + Name + "] Msg [" + msg + "]" );

    // If chat is from us then...
    if (Name == skapi.szName)
    {
	if (msg == "reset")
	{
	    RemoveInterface();
	    DisplayInterface();
	    return;
	} // endif
    } // endif

    // If chat logging enabled and player not on ignore list, then log output to file
    if (flagLogChat) {
    	for (var x = 0; x < chatIgnoreList.length; x++) if (Name == chatIgnoreList[x]) break;
    	if (x == chatIgnoreList.length) {
	    ChatLog.WriteLineD("Local: " + Name + " says, \"" + msg + "\"" );
	} // endif
    } // endif

    var MsgUp = msg.toUpperCase();
    // Chat.Screen("MsgUp [" + MsgUp + "] Whereto Index [" + MsgUp.indexOf("!WHERETO") + "]");
    if ((MsgUp.indexOf("!WHERETO") >= 0) || (MsgUp.indexOf("WHERETO!") >= 0)) ListPortals(Name);

    // If we are accepting portal keywords from local chat and summoning
    // is enabled, then see if the local chat is a portal name
    if (flagAcceptLocal && SummonMode) {	
	// See if local chat person is on ignore list.  If so then we ignore the chat
	var Valid = true;
	for (var x=0; x<ignoreList.length; x++) {
	    if (ignoreList[x] == Name) {
		Valid = false;
		break;
	    } // endif
	} //endfor

    	// Get rid of name says, " in front, and " at end
    	if (Valid) {
	    var pattern = new RegExp ( "(^.*says, \"|\"$)", "g" );
	    PortalIdent = msg.replace(pattern, "");
	    FindKeyword(PortalIdent,Name);
	} // endif
    } // endif

    if (debugEvent||debugCmds) Log.OutD("Main_OnChatLocal: End");
} // end function MainHandlers_OnChatLocal


// OnChatServer
function MainHandlers_OnChatServer(text, code) {
    if (debugEvent) Log.OutD("Main_OnChatServer: Text [" + text + "] Type [" + code + "]" );

    // Following patterns will...
    var Pattern3 = new RegExp ( "^.* gives you .*$", "g" );	// detect gifts given to us
    var Pattern4 = new RegExp ( " gives you .*", "g" );		// determine the gift giver
    var Pattern5 = new RegExp ( "(.* gives you |.$)", "g" );	// extract the gift name

    if (Pattern3.test(text)) {
    	var Who = text.replace(Pattern4, "");
    	var Gift = text.replace(Pattern5, "");
    	if (logGifts||debugEvent) Log.OutD("Main_OnChatServer: Gift. Who [" + Who + "] Item [" + Gift + "]" );
    	if (flagAckGifts) Chat.Local("Thank you for the " + Gift + " " + Who);
    	if (flagLogGifts) GiftLog.WriteLineD("From: " + Util.Pad(Who,25) + " Gift: " + Gift);
    	return;
    } // endif

    if (debugEvent) Log.OutD("Main_OnChatServer: End" );
} // end function MainHandlers_OnChatServer


function MainHandlers_OnCommand(szCmd) {
    if (debugEvent||debugCmds) Log.OutD("Main_OnCommand: Begin, Command [" + szCmd + "]", true);

    var Split = szCmd.split(" ");
    for (var x=0; x<Split.length; x++) {
	Split[x] = Util.Trim(Split[x]);
	if (debugCmds) Log.OutD("Main_OnChatLocal: Split # [" + x + "] Value [" + Split[x] + "]", true);
    } // endfor

    var Command = Split[0].toUpperCase();
    if (debugCmds) Log.OutD("Main_OnChatLocal: Command [" + Command + "]", true);

    if (debugEvent||debugCmds) Log.OutD("Main_OnCommand: End", true);
    return;
} // end function


// OnDeathSelf()
function MainHandlers_OnDeathSelf( acoKiller, msg) {
    Log.OutD("Main_OnDeathSelf: Player killed by id [" + Util.Hex(acoKiller.oid) + "] Name [" +
		acoKiller.szName + "] Msg [" + msg + "]", true);

    Dead = true;		// Set to true when we die.  Triggers special death processing
    DeathStart = new Date();

    StateChange(stateDied,NoCheck);
    Log.OutD("Main_OnDeathSelf: End");
    return;
} // end func


// OnDisconnect
function MainHandlers_OnDisconnect() {
    Log.OutD("Main_OnDisconnect: Begin");
    Log.OutD("Main_OnDisconnect: Unexpected event, exiting macro...");
    StateChange(stateExit,NoCheck);
    RunFlag = 0;
    Log.OutD("Main_OnDisconnect: End");
} // end func


// OnEnd3D
function MainHandlers_OnEnd3D() {
    Log.OutD("Main_OnEnd3D: Begin");
    CharOnEnd3D = true;

    // If we are we are resetting the ac client, switching chars, logging off, or hiding from danger,
    // or just logging on then this event is expected so just return
    if ((State==stateLog) || (State==stateHide) || (State==stateReset)) {
    	Log.OutD("Main_OnEnd3D: End, Expected event. State [" + State + "/" + textState[State] + "]");
    	return;
    } // endif

    // Unexpected OnEnd3D message encountered, exit macro
    Log.OutD("Main_OnEnd3D: Unexpected event, exiting macro...");
    StateChange(stateExit,NoCheck);
    RunFlag = 0;
    Log.OutD("Main_OnEnd3D: End");
} // end func


function MainHandlers_OnEndPortalSelf() {
    if (debugEvent) Log.OutD("Main_OnEndPortalSelf:  Portal has ended");
    CharEndPortal = true;
} // end function


// OnMeleeDamageSelf
function MainHandlers_OnMeleeDamageSelf(name, damage, type, bpart) {
    if (debugEvent) Log.OutD("Main_OnMeleeDamageSelf: Attacker [" + name + "] Damage [" + damage +
			     "] Type [" + type + "] Body Part [" + bpart + "]" );

    LastAttTime      = new Date();
    LastMeleeDamTime = new Date();
    LastMeleeDamName = name;
    LastMeleeDamAmt  = damage;
    LastMeleeDamType = type;
    LastMeleeDamPart = bpart;

    Log.OutD("Main_OnMeleeDamageSelf: Attacker [" + name + "] Damage [" + damage +
	     "] Type [" + Util.Hex(type) + "] Body Part [" + damBody[bpart] + "]");
    
    if (flagDamageLog) {
	Log.OutD("OnMeleeEvadeSelf: Old state [" + State + "], changing state to hide...");
	StateChange(stateHide);
    } // endif
} // end function


// OnMeleeEvadeSelf
function MainHandlers_OnMeleeEvadeSelf(Name) {
    if (debugEvent) Log.OutD("Main_OnMeleeEvadeSelf: Source [" + Name + "]");

    LastMeleeEvade = new Date();
    LastAttTime = new Date();

    if (flagDamageLog) {
	Log.OutD("OnMeleeEvadeSelf: Old state [" + State + "], changing state to hide...");
	StateChange(stateHide);
    } // endif
} // end function


function MainHandlers_OnObjCre(aco) {
    if (debugEvent||debugEvade)
	Log.OutD("Main_OnObjCre: Begin, Obj [" + aco.szName + "] Oid [" + Util.Hex(aco.oid) + "] created");

    // See if object created is a war spell
    var Name = aco.szName;
    if ((flagWarAvoid) &&
        (Name.match(/((Flame|Frost|Lightning|Force) Bolt|Whirling Blade|Shockwave|Acid Stream|Missile)/))) {
    	if (debugEvade) Log.OutD("Main_OnObjCre: Object seems to be a war spell");
    	// War spell detected, see if it is heading in our direction
    	var OurLoc = skapi.maplocCur;
	var ObjLoc = aco.maploc;
	if (ObjLoc == null) {
	    if (debugEvade) Log.OutD("Main_OnObjCre: War spell [" + Name + "] does not have a maploc, aborting check");
	    return;
	} // endif

	// If war spell created really close to us, then don't attempt to move
	var Distance = Util.Distance(ObjLoc,OurLoc);
	if (Distance < avoidMinDist) {
	    if (debugEvade) Log.OutD("Main_OnObjCre: War spell too close to avoid, aborting check");
	    return;
	} // endif

	// Ok we have all the data we need to calculate how close the bolt will come to us
	// and it's far enough away for us to move out of the way.  Now see it it will hit us.
	var HeadToUs = ObjLoc.HeadToMaploc(OurLoc);
	var Angle    = ObjLoc.head - HeadToUs;
	var Radians  = (Angle*2*Math.PI)/360;
	var Closest  = Distance*Math.sin(Radians);

	// Now see if the angles are close.  If not abort the check.  We do this because a war spell
	// heading away from us 180 degrees could generate a false positive.
	var Diff = Math.abs(Angle)
	if (Diff > 180) Diff=360-Diff;
	if (Diff>avoidMaxAngle) {
	    if (debugEvade)  Log.OutD("Main_OnObjCre: Angle diff [" + Diff + "] aborting check");
	    return;
	} // endif

	if (debugEvade) {
	    Log.OutD("Main_OnObjCre: War Spell   [" + Name		+ "] detected");
	    Log.OutD("Main_OnObjCre: Obj Coords  [" + Util.FormatCoords(ObjLoc,3) + "]");
	    Log.OutD("Main_OnObjCre: Heading     [" + ObjLoc.head	+ "]");
	    Log.OutD("Main_OnObjCre: Distance2Us [" + Distance		+ "]");
	    Log.OutD("Main_OnObjCre: Obj Head2Us [" + HeadToUs		+ "]");
	    Log.OutD("Main_OnObjCre: Our Heading [" + OurLoc.head	+ "]");
	    Log.OutD("Main_OnObjCre: AngleDiff   [" + Angle		+ "]");
	    Log.OutD("Main_OnObjCre: Radians     [" + Radians		+ "]");
	    Log.OutD("Main_OnObjCre: Closest     [" + Closest		+ "]");

	} // endif

	if (Math.abs(Closest) > avoidDangerThresh) {
	    if (debugEvade) Log.OutD("Main_OnObjCre: War spell will miss us, aborting check.");
	    return;
	} else {
	    if (debugEvade) Log.OutD("Main_OnObjCre: War spell will hit us.");
	} // endif

	// Ok war spell will most likely hit us, so try to move out of the way. If we are in the
	// middle of casting a spell and slidecasting is enabled then try to slidecastset, otherwise
	// set a flag so that the FSM will try to move us.  We don't do it here since we may be in
	// the middle of casting a spell when this event fires and any movement may abort the spell. 
	
	if (flagSlideCast && CastActive) {
	    if ((new Date()-LastSlideTime)>avoidSlideHold) {
		if (debugEvade) Log.OutD("Main_OnObjCre: We are casting a spell, trying to slidecast...");
		WarEvade(true);
		LastSlide = new Date();
	    } else {
	    	if (debugEvade) Log.OutD("Main_OnObjCre: Tried to slide too recently, ignoring war spell..");
	    } // endif
	} else {
	    if (debugEvade) Log.OutD("Main_OnObjCre: We are not casting a spell, setting EvadeWar flag.");
	    EvadeWar = true;
	} // endif
	return;
    } // endif

    if (debugEvent||debugEvade) Log.OutD("Main_OnObjCre: End");
} // end function MainHandlers_OnObjCre


// OnObjCrePlayer
function MainHandlers_OnObjCrePlayer(aco) {
    Log.OutD("Main_OnObjCrePlayer: Begin, Name [" + aco.szName + "]");

    var Name = aco.szName;

    // If player detected is ourselves, then we are done
    if (Name == skapi.szName) return;

    var ObjLoc = aco.maploc;
    var OurLoc = skapi.maplocCur;
    var Distance = Util.Distance(ObjLoc, OurLoc);

    // Log event if flag set
    if (logPlayers) {
    	Log.OutD("OnObjCrePlayer: Player detected [" + Name + "] Dist [" + Distance + "] Coords [" +
    		 Util.FormatCoords(ObjLoc,3) + "]");
   	Log.OutD("OnObjCrePlayer: Heading [" + Util.Round(ObjLoc.head,0) + "] OurCoords [" +
   		 Util.FormatCoords(OurLoc,3) + "] Head2Us [" + Util.Round(ObjLoc.HeadToMaploc(OurLoc),0) + "]");

   	// See how close player will come to us on current heading and report info
	var HeadToUs = ObjLoc.HeadToMaploc(OurLoc);
	var Angle    = ObjLoc.head - HeadToUs;
	var Radians  = (Angle*2*Math.PI)/360;
	var Closest  = Math.abs(Distance*Math.sin(Radians));
	Log.OutD("OnObjCrePlayer: Closest distance player will come to us [" + Util.Round(Closest,3) + "]");
    } // endif

    // Send info to chat screen if flag set
    if (flagReportPlayer) {
    	var OutLine = "Player detected: " + Util.Width(Name,1.7) + "   Dist: " + Util.Round(Distance,2);
    	if (Distance > 0.01)
	    OutLine = OutLine + "   Heading: " + Util.Round(OurLoc.HeadToMaploc(ObjLoc),0) +
				"   Coords: " + Util.FormatCoords(ObjLoc,2);
	Chat.Screen(OutLine);
    } // endif

    Log.OutD("Main_OnObjCrePlayer: End");
    return;
} // end func


// OnPortalStormed
function MainHandlers_OnPortalStormed() {
    Log.OutD("Main_OnPortalStormed: Begin");
    StateChange(stateStormed);
    Log.OutD("Main_OnPortalStormed: End");
}

// OnPortalStormWarning
function MainHandlers_OnPortalStormWarning(severity) {
    if (debugEvent) Log.OutD("Main_OnPortalStormWarning:  Lvl (" + severity + ") warning received");

    // If severity is not an end portal storm code then process warning
    if (severity != pswStormEnded) {
	// If we are not already processing the portal storm warning, then set portal storm
	// warning flag.
	if (State !=stateReset) {
	    CharStormWarn = true;
	    Log.OutD("Main_OnPortalStormWarning: Portal storm detected. Severity [" + severity + "]" );
	} // endif
    } // endif

    if (debugEvent) Log.OutD("Main_OnPortalStormWarning: End");
} // end function


function Respond(Name, Msg) {
    // If name to send is our character, then can't use @tell,
    // so just send message to chat area directly
    if (Name == skapi.szName) {
	Chat.Screen(Msg);
    } else {
	if (Name == "ALLEG") {
	    Chat.Allegiance(Msg);
	} else if (Name == "GENERAL") {
	    Chat.General(Msg);
	} else {
	    Chat.Tell(Name, Msg);
	} // endif
    } // endif
} // end func


function ProcessCommand(Name, Msg, acoSender) {
    if (flagLogCmds) CmdLog.WriteLineD("From: " + Util.Pad(Name, 25) + " Cmd: " + Msg);

    var Split = Msg.split(" ");
    for (var x=0; x<Split.length; x++) {
    	Split[x] = Util.Trim(Split[x]);
    	if (debugCmds) Log.OutD("ProcessCommand: Split # [" + x + "] Value [" + Split[x] + "]");
    } // endif
    var Command = Split[0].toUpperCase();
    if (debugCmds) Log.OutD("ProcessCommand: Command [" + Command + "] Param1 [" + Split[1] + "]");

    if (Command == "HELP") {
	if (debugEvent) Log.OutD("ProcessCommand: Command HELP detected. Who [" + Name + "] Message [" + Msg + "]");
	for (var x=0; x<BroadHelpCnt; x++) Respond(Name, BroadHelp[x]);
	return;
    } // endif

    if ((Command == "LIST") || (Command == "WHERETO")) {
    	if (debugEvent) Log.OutD("ProcessCommand: Command LIST detected. Who [" + Name + "] Message [" + Msg + "]");
	ListPortals(Name);
 	return;   		
    } // endif
    
    // LOC command will report our location
    if (Command == "LOC") {
	var OurLoc = skapi.maplocCur;
	Log.OutD("ProcessCommand: LOC command detected");
	Respond(Name, "My location is [" + Util.FormatCoords(OurLoc,2) + "]");
	return;
    } // endif
    
    if (Command == "STATS") {
       	if (debugEvent) Log.OutD("ProcessCommand: Command STATS detected. Who [" + Name + "]");
       	BuildPortalStats();
        for (var x=0; x<StatList.length; x++) Respond(Name,StatList[x]);
	return;
    } // endif
    
    if (Command == "COMPS") {
	if (debugEvent) Log.OutD ("ProcessCommand: Command COMPS detected. Who [" + Name + "]" );
	// Chat.Screen("Comps: Name [" + Name + "]");
	ReportComps(Name);
	return;
    } // endif

    // If flag is set to only allow people who are close to us to issue summon commands,
    // and we are not an admin user, then make sure requestor is close to us.  
    if (flagCloseOnly && !AdminUser) {
    	var RequestorMapLoc = acoSender.maploc;
    	if ((RequestorMapLoc == undefined) || (RequestorMapLoc == null)) {
	    var PlayerDist = 9999;
	} else {
	    var OurMapLoc = skapi.maplocCur;
	    if ((OurMapLoc == undefined) || (OurMapLoc == null)) {
		var PlayerDist = 0;
		Log.OutD ("ProcessCommand: skapi.maplocCur is undefined or null");
	    } else {
		var PlayerDist = Util.Distance(OurMapLoc, RequestorMapLoc);
	    } //endif
	} // endif

	if (PlayerDist > closebyDist) {
	    Respond(Name, "You must be within " + closebyDist + " map units to use this bot.");
	    return;
	} // endif
    } // endif

    // Check for summon keyword
    if (Command == "SUMMON") {	
	// Parse out word after summon
	if (Split.length < 2) {
	    Respond(Name,"%No portal keyword specified.");
	    return;
	} // endif

	// In case player put the ' character around the keyword, remove them
	var pattern = new RegExp ( "(^'|'$)", "g" );

	var PortalIdent = Util.Trim(Msg.substr(7));
	PortalIdent = PortalIdent.replace(pattern, "");
	if (debugEvent) Log.OutD("ProcessCommand: Portal keyword [" + PortalIdent + "]");
	
	if (FindKeyword(PortalIdent,Name)) return;	// If keyword found, then return
	
	Respond(Name,"Unrecognized portal [" + PortalIdent + "]. Use LIST command to see valid portals");
	return;    	
    } // endif

    if (flagPortalGems && (Command == "GEM")) {	
	// Parse out word after summon
	if (Split.length < 2) {
	    Respond(Name,"%No starter town specified.");
	    return;
	} // endif

	// In case player put the ' character around the keyword, remove them
	var pattern = new RegExp ( "(^'|'$)", "g" );

	var GemIdent = Util.Trim(Msg.substr(4));
	GemIdent = GemIdent.replace(pattern, "");
	if (debugEvent) Log.OutD("ProcessCommand: Gem keyword [" + GemIdent + "]");
	
	if (FindGem(GemIdent,Name)) return;	// If keyword found, then return
	Respond(Name,"Unrecognized town " + GemIdent + ". Valid towns are: " + portalGemList);
	return;    	
    } // endif
    
    // Now look for special admin commands.  Only people on admin list can issue these commands
    if (AdminUser) {
	if (Command == "DISABLE") {
	    if (debugEvent) Log.OutD ("ProcessCommand: Command DISABLE detected through @tell");
	    SummonMode = false;
	    skapi.SetControlProperty(szPanelControl, "btnSummonMode", "Text", "Enable Summoning");
	    Log.OutD("Non-admin commands disabled through @tell");
	    Respond(Name, "Portal summoning disabled.");
	    return;
	} // endif
    
	if (Command == "ENABLE") {
	    if (debugEvent) Log.OutD ("ProcessCommand: Command ENABLE detected");
	    SummonMode = true;
	    skapi.SetControlProperty(szPanelControl, "btnSummonMode", "Text", "Disable Summoning");
	    Log.OutD("Non-admin commands enabled");
	    Respond(Name, "Portal summoning enabled.");
	    return;
	} // endif
    
	if (Command == "SWITCH") {
	    if (debugEvent) Log.OutD ("ProcessCommand: Command SWITCH detected");
	    var CharName = Util.Trim(Msg.substr(7));
	    if (CharName.toUpperCase() == "NEXT") {
		// Find next character that has enabled portals
		var NewChar = FindNextActive();
		if (NewChar == AccCurChar) {
		    Respond("No active portals on other chars");
		    return;
		} // endif
	    } else {
		var NewChar = Player.ToSlotNum(CharName);
	    } // endif
	    if (NewChar<0) {
		Log.OutD("Unrecognized character name [" + CharName + "]" );
		Respond(Name, "Unrecognized character name [" + CharName + "]" );
		return;
	    } // endif
		
	    if (NewChar==AccCurChar) {
		Log.OutD("Already on character  [" + skapi.rgszChar(NewChar) + "]" );
		Respond(Name, "Already on character [" + skapi.rgszChar(NewChar) + "]" );
		return;
	    } // endif
		
	    Log.OutD("Switching to character [" + skapi.rgszChar(NewChar) + "] next time we are idle" );
	    Respond(Name, "Switching to character " + skapi.rgszChar(NewChar) + " next time we are idle" );
	    SwitchChar = NewChar;
	    return;
	} // endif

	// STOP command will stop the macro
	if (Command == "STOP") {
	    Log.OutD("ProcessCommand: STOP command detected");
	    Respond(Name, "STOP command acknowledged, logging character and ending macro");
	    StateChange(stateLog,NoCheck);
	    return;
	} // endif

    } // endif
    
    // See if command matches portal keyword. In case player put the ' characters around the keyword, remove them
    PortalIdent = Command.replace(pattern, "");
    if (FindKeyword(PortalIdent,Name)) return;	// If keyword found, then return
  
    // If we make it here, then we don't recognized the command.  Tell the person so.
    Respond(Name, "Unrecognized command or portal keyword, for instructions @tell me, help" );
    return;
} // end func


// ParseChatTells - Parse message received from @tell or local chat for portal commands
//
function ParseChatTell(acoSender, acoReceiver, Msg) {
    if (debugEvent) Log.OutD("ParseChatTells: Begin, Msg [" + Msg + "]");
    Name = acoSender.szName

    // First see if the person talking to us is an admin user.
    // We only accept admin commands from people on admin list. 
    AdminUser = false;
    if (Authorized(acoSender.szName)) {
	if (debugCmds) Log.OutD("ProcessTell: Authorized source");
	AdminUser = true;
    } // endif
    
    // Parse message if accept flag enabled
    if (!SummonMode && !AdminUser) {
	Respond(acoSender.szName, "Bot temporarily disabled.  Try again in a few minutes");
	return;
    } // endif

    // See if requestor is on ignore list
    for (var x=0; x<ignoreList.length; x++) {
    	if (ignoreList[x] == Name) {
	    Log.OutD("ParseChatTells: Ignoring player [" + Name + "] Msg [" + Msg + "]");
	    if ((new Date()-LastIgnoreTime) > 3000) {
		Respond(Name, "Leave me alone");
		LastIgnoreTime = new Date();
	    } // endif
	    return;
    	} // endif
    } //endfor
    
    ProcessCommand(Name, Msg, acoSender);
    return;
} // end function


// OnTell
function MainHandlers_OnTell(acoSender, acoReceiver, msg) {
    if (debugEvent) Log.OutD("Main_OnTell: Begin");

    // If macro not fully configured, then ignore tells for now
    if (Restricted) return;
    
    // Parse the @tell
    ParseChatTell(acoSender, acoReceiver, msg);
    if (debugEvent) Log.OutD("Main_OnTell: End");
} // end func


// OnTellFellowship
function MainHandlers_OnTellFellowship(szSender, szMsg) {
    if ((szSender == null) || (szSender == "")) szSender = skapi.szName;
    if (debugEvent) Log.OutD("OnTellFellowship: Begin, Who [" + szSender + "] Msg [" + szMsg + "]" );

    // We only accept fellowship commands from ourselves
    if (szSender != skapi.szName) return;
    
    // Commands from us via fellow always run with admin privileges
    AdminUser = true;
    ProcessCommand(szSender, szMsg, null);

    if (debugEvent) Log.OutD("Main_OnTellFellowShip: End" );
} // end func


// OnVitals
function MainHandlers_OnVitals( health, stam, mana) {
    if (debugEvent) Log.OutD("Main_OnVitals: Health [" + health + "] Stam [" + stam + "] Mana [" + mana + "]" );
} // end func


function MainHandlers() {
	this.OnActionComplete	  = MainHandlers_OnActionComplete;
	this.OnChatBoxMessage	  = MainHandlers_OnChatBoxMessage;
	this.OnChatBroadcast	  = MainHandlers_OnChatBroadcast;
	this.OnChatLocal	  = MainHandlers_OnChatLocal;
	this.OnChatServer	  = MainHandlers_OnChatServer;
	this.OnCommand		  = MainHandlers_OnCommand;
	this.OnControlEvent	  = MainHandlers_OnControlEvent;
	this.OnDeathSelf	  = MainHandlers_OnDeathSelf;
	this.OnDisconnect	  = MainHandlers_OnDisconnect;
	this.OnEnd3D		  = MainHandlers_OnEnd3D;
	this.OnEndPortalSelf 	  = MainHandlers_OnEndPortalSelf;
	this.OnMeleeDamageSelf	  = MainHandlers_OnMeleeDamageSelf;
	this.OnMeleeEvadeSelf	  = MainHandlers_OnMeleeEvadeSelf;
	this.OnObjectCreate	  = MainHandlers_OnObjCre;
	this.OnObjectCreatePlayer = MainHandlers_OnObjCrePlayer;
	this.OnPortalStormed	  = MainHandlers_OnPortalStormed;
	this.OnPortalStormWarning = MainHandlers_OnPortalStormWarning;
	this.OnTell		  = MainHandlers_OnTell;
	this.OnTellFellowship	  = MainHandlers_OnTellFellowship;
	this.OnVitals		  = MainHandlers_OnVitals;
} // end func

function fAddHandlers() {
    // Active handlers
    MainH = new MainHandlers();
    skapi.AddHandler( evidOnActionComplete,	MainH );
    skapi.AddHandler( evidOnChatBoxMessage,     MainH );
    skapi.AddHandler( evidOnChatBroadcast,	MainH );
    skapi.AddHandler( evidOnChatLocal,		MainH );
    skapi.AddHandler( evidOnChatServer,		MainH );
    skapi.AddHandler( evidOnCommand,		MainH );
    skapi.AddHandler( evidOnControlEvent,	MainH );
    skapi.AddHandler( evidOnDeathSelf,		MainH );
    skapi.AddHandler( evidOnDisconnect,		MainH );
    skapi.AddHandler( evidOnEnd3D,		MainH );
    skapi.AddHandler( evidOnEndPortalSelf,	MainH );
    skapi.AddHandler( evidOnMeleeDamageSelf,	MainH );
    skapi.AddHandler( evidOnMeleeEvadeSelf,	MainH );
    skapi.AddHandler( evidOnObjectCreate,	MainH );
    skapi.AddHandler( evidOnObjectCreatePlayer,	MainH );
    skapi.AddHandler( evidOnPortalStormed,	MainH );
    skapi.AddHandler( evidOnPortalStormWarning,	MainH );
    skapi.AddHandler( evidOnTell,		MainH );
    skapi.AddHandler( evidOnTellFellowship,	MainH );
    skapi.AddHandler( evidOnVitals,		MainH );
    


} // end func

function fRemoveHandlers() {
    // Active handlers
    skapi.RemoveHandler( evidOnActionComplete,		MainH );
    skapi.RemoveHandler( evidOnChatBoxMessage,	        MainH );
    skapi.RemoveHandler( evidOnChatBroadcast,		MainH );
    skapi.RemoveHandler( evidOnChatLocal,		MainH );
    skapi.RemoveHandler( evidOnChatServer,		MainH );
    skapi.RemoveHandler( evidOnCombatMode,		MainH );
    skapi.RemoveHandler( evidOnCommand,			MainH );
    skapi.RemoveHandler( evidOnControlEvent,		MainH );
    skapi.RemoveHandler( evidOnDeathSelf,		MainH );
    skapi.RemoveHandler( evidOnDisconnect,		MainH );
    skapi.RemoveHandler( evidOnEnd3D,			MainH );
    skapi.RemoveHandler( evidOnEndPortalSelf,		MainH );
    skapi.RemoveHandler( evidOnMeleeDamageSelf,		MainH );
    skapi.RemoveHandler( evidOnMeleeEvadeSelf,		MainH );
    skapi.RemoveHandler( evidOnObjectCreate,		MainH );
    skapi.RemoveHandler( evidOnObjectCreatePlayer,	MainH );
    skapi.RemoveHandler( evidOnPortalStormed,		MainH );
    skapi.RemoveHandler( evidOnPortalStormWarning,	MainH );
    skapi.RemoveHandler( evidOnTell,			MainH );
    skapi.RemoveHandler( evidOnTellFellowship,		MainH );
    skapi.RemoveHandler( evidOnVitals,			MainH );

  

} // end func

// ***************************************************************************************************
                                                                                                                                                                                                                                                                                                                                                                                                         